<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'share';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'share');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 会员模块
include_once (ROOT_PATH . 'include/user.class.php');
$dou_user = new DouUser();

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center('share', 'admin'));

/**
 * +----------------------------------------------------------
 * 售后列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['share']);
 
    // 初始化
    $page_url = 'share.php';
 
    // 用户名
    $username = $check->is_username($_REQUEST['username']) ? $_REQUEST['username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($username);
        $where = " AND user_id = '$user_id'";
        $page_url = $page_url . "&username=$username";
    }

    // 筛选.类型
    $share_sn = $check->is_number($_REQUEST['share_sn']) ? $_REQUEST['share_sn'] : '';
    if ($share_sn) {
        $where = $where . " AND share_sn LIKE '%$share_sn%'";
        $page_url = $page_url . "&share_sn=$share_sn";
    }
 
    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $where = $_SESSION['where'] = $dou->where($where);
    $page_url = $dou->param($page_url);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('share') . $where . " ORDER BY id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $dou->param($page_url), $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 获取的积分
        if ($_OPEN['point'])
            $point = $dou->get_one("SELECT point FROM " .$dou->table('user_point') . " WHERE user_id = '$user_id' AND action = 'share' AND `from` = '$row[share_sn]' ORDER BY id DESC");
        
        $share_list[] = array (
                "id" => $row['id'],
                "share_sn" => $row['share_sn'],
                "user" => $dou->user_basic($row['user_id']),
                "img_list" => $dou->get_file_list('share', $row['share_sn'], 'gallery', true),
                "handle_record" => $row['handle_record'],
                "handle_time" => $row['handle_time'] ? date("Y-m-d H:i", $row['handle_time']) : '-',
                "point" => $point ? $point : '-',
                "status" => $dou->data_lang_format('share_status_', $row['status']),
                "add_time" => date("Y-m-d H:i", $row['add_time'])
                
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('share_list', $share_list);
    
    $smarty->display('share.htm');
} 

/**
 * +----------------------------------------------------------
 * 售后编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['share']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['share_list'],
            'href' => 'share.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 格式化服务单信息
    $share = $dou->get_row('share', '*', "id = '$id'");
    $share['if_handle'] = $share['status'] ? true : false; // 是否已处理
    $share['status'] = $dou->data_lang_format('share_status_', $share['status']);
    $share['add_time'] = date("Y-m-d H:i:s", $share['add_time']);
    $share['user'] = $dou->user_basic($share['user_id']);
    $share['img_list'] = $dou->get_file_list('share', $share['share_sn'], 'gallery', true);
    
    // 强制解锁
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('share', $share);
    $smarty->assign('unlock', $unlock);
    
    $smarty->display('share.htm');
}

/**
 * +----------------------------------------------------------
 * 售后处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'handle') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 售后信息
    $share = $dou->get_row('share', '*', "id = '$id'");
    if ($share['status'] == 1 && !$unlock) // 强制解锁状态可以重复修改售后信息
        $dou->dou_msg($_LANG['share_handle_wrong']);
 
    // 处理说明
    if (empty($_POST['handle_record']))
        $dou->dou_msg($_LANG['share_handle_record'] . $_LANG['is_empty']);
 
    // 格式化数据
    $handle_time = time();
 
    // 变更售后状态
    $result = $dou->query("UPDATE " . $dou->table('share') . " SET handle_record = '$_POST[handle_record]', handle_time = '$handle_time', `status` = '1' WHERE id = '$id'");
 
    // 积分奖励
    if ($result && $_OPEN['point']) {
        $dou_user->create_point($share['user_id'], 'share', ($_PARAM['share_point'] ? $_PARAM['share_point'] : 10), $share['share_sn']);
    }
    
    $dou->dou_header('share.php?rec=view&id=' . $id);
}

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'cancel_all') {
            // 售后批量删除
            $dou_share->cancel_all($_POST['checkbox']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['share_select_empty']);
    }
}

/**
 * +----------------------------------------------------------
 * 参数设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $set_list = array('share_point');
    foreach ($set_list as $name) {
        if (!$dou->value_exist('parameter', 'name', $name)) {
            $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG[$name . '_lang'] . "', '" . $_LANG[$name . '_value'] . "', '" . $_LANG[$name . '_cue'] . "', 'share')");
        }
    }
    $dou->dou_header('parameter.php?rec=set&group=share');
}

?>